unit AffU;

interface

uses SysUtils, Windows, Classes, Graphics, Forms, Controls, Buttons,
   StdCtrls, Spin, ExtCtrls, ComCtrls,
   maths, uniteker, orphyLabUtil,
   orphyLabDef, orphyLabGraphe, orphyLabMainU, orphyLabConst;

type
   TAffichageDlg = class(TForm)
      OKBtn:           TBitBtn;
      CancelBtn:       TBitBtn;
      Panel1:          TPanel;
      GroupBox1:       TGroupBox;
      GrilleCB:        TCheckBox;
      Label1:          TLabel;
      DimPointSE:      TSpinEdit;
      AnalyseurRG:     TRadioGroup;
    TraceRG: TRadioGroup;
    LoupeCB: TCheckBox;
    PeriodeRG: TRadioGroup;
    RemanenceCB: TCheckBox;
      procedure OKBtnClick(Sender: TObject);
      procedure FormActivate(Sender: TObject);
   private
   public
   end;

var
   AffichageDlg: TAffichageDlg;

implementation

{$R *.DFM}

procedure TAffichageDlg.OKBtnClick(Sender: TObject);
begin with graphe do begin
      LoupeAuto := loupeCB.Checked;
      affichagePeriode := TaffichagePeriode(periodeRG.itemIndex);
      AnalyseurLogique := analyseurRG.ItemIndex = 1;
      ModeTrace := TmodeTrace(traceRG.itemIndex);
      Quadrillage := GrilleCB.Checked;
      dimPoint := dimPointSE.Value;
      remanence := RemanenceCB.Checked;
end end;

procedure TAffichageDlg.FormActivate(Sender: TObject);
begin with graphe do begin
      periodeRG.itemIndex := ord(affichagePeriode);
      loupeCB.Checked := LoupeAuto;
      analyseurRG.ItemIndex := Ord(AnalyseurLogique);
      TraceRG.itemIndex  := ord(modeTrace);
      GrilleCB.Checked := Quadrillage;
      DimPointSE.Value := dimPoint;
      RemanenceCB.Checked := remanence;
end end;

end.

