program OrphyLab;

uses
  Forms,
  OrphyLabMainU in 'OrphyLabMainU.pas' {OrphyLabMain},
  OrphyLabGraphe in 'OrphyLabGraphe.pas',
  OrphyLabUtil in 'OrphyLabUtil.pas',
  MATHS in 'MATHS.PAS',
  Uniteker in 'Uniteker.pas',
  OrphyLabDlgU in 'OrphyLabDlgU.pas' {OrphyLabDlg},
  OrphyLabReg in 'OrphyLabReg.pas' {ConstanteDlg},
  OrphyLabAboutU in 'OrphyLabAboutU.pas' {OrphyLabAbout},
  OrphyLabDDEU in 'OrphyLabDDEU.pas' {OrphyLabDDE},
  OrphyLabDef in 'OrphyLabDef.pas',
  ETALON in 'ETALON.PAS' {EtalonneInterDlg},
  Oneinst in 'Oneinst.pas',
  sbdlg in 'sbdlg.pas' {SortieBinDlg},
  optPro in 'optPro.pas' {OptionsDlg},
  MagnumDlg in 'MagnumDlg.pas' {MagnumCfg},
  SysInfoCtrls in 'SysInfoCtrls.pas',
  OrphyLabFreqU in 'OrphyLabFreqU.pas' {OrphyFrequenceDlg},
  voieCalcCfg in 'voieCalcCfg.PAS' {voieCalcDlg},
  gbf_syntaxe in 'gbf_syntaxe.pas' {SyntaxeDlg},
  lecttext in 'lecttext.pas' {LectureTexteDlg},
  options_ligne in 'options_ligne.pas' {OptionLigneDlg},
  SortieAna_comp in 'SortieAna_comp.pas',
  keysu in 'keysu.pas',
  curseursU in 'curseursU.pas' {CurseursForm},
  MagnumStop in 'MagnumStop.pas' {MagnumStopDlg},
  synchroU in 'synchroU.PAS' {SynchroDlg},
  AffU in 'AffU.PAS' {AffichageDlg},
  clavierU in 'clavierU.PAS' {clavierDlg},
  OrphyLabConst in 'OrphyLabConst.pas',
  lumicolorU in 'lumicolorU.PAS' {lumicolorDlg},
  CapteurDlgU in 'CapteurDlgU.pas' {CapteurDlg},
  ETALON6V in 'ETALON6V.PAS' {Etalonne6VDlg},
  RadarDlg in 'RadarDlg.pas' {RadarCfg},
  LISTECAPvolt in 'LISTECAPvolt.PAS' {ListeCapteursVoltDlg},
  capteurCfgU in 'capteurCfgU.pas' {CapteurCfg},
  ChoixcapteursU in 'ChoixcapteursU.pas' {ChoixCapteursDlg},
  VumetreU in 'VumetreU.pas' {VumetreForm},
  UICfg in 'UICfg.pas' {UIcfgDlg},
  DdeMan in 'DdeMan.pas',
  photocolorU in 'photocolorU.PAS' {photocolorDlg},
  zeroU in 'zeroU.pas' {ZeroDlg},
  Parser10 in 'Parser10.pas',
  aidekey in 'aidekey.pas',
  capsuleCfgU in 'capsuleCfgU.pas' {CapsuleCfgDlg};

{$R *.RES}

begin
  Application.Title := 'Orphy Lab';
  Application.HelpFile := 'MicroPortable\OrphyLab.HLP';
  EnsureSingleInstance;
  Application.CreateForm(TOrphyLabMain, OrphyLabMain);
  Application.CreateForm(TOrphyLabDlg, OrphyLabDlg);
  Application.CreateForm(TConstanteDlg, ConstanteDlg);
  Application.CreateForm(TOrphyLabDDE, OrphyLabDDE);
  Application.CreateForm(TOptionsDlg, OptionsDlg);
  Application.CreateForm(TSynchroDlg, SynchroDlg);
  Application.CreateForm(TAffichageDlg, AffichageDlg);
  Application.CreateForm(TEtalonne6VDlg, Etalonne6VDlg);
  Application.CreateForm(TUIcfgDlg, UIcfgDlg);
  Application.CreateForm(TZeroDlg, ZeroDlg);
  Application.Run;
end.
