unit OrphyLabAboutU;

interface

uses Windows, Classes, Graphics, Forms, StdCtrls,
  Buttons, ExtCtrls, shellapi, dialogs, Controls;

type
  TOrphyLabAbout = class(TForm)
    Panel1: TPanel;
    OKButton: TBitBtn;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    ProgramIcon: TImage;
    Label1: TLabel;
    Label2: TLabel;
    ROMLabel: TLabel;
    ROM1: TLabel;
    BitBtn1: TBitBtn;
    ROM2: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
  public
  end;

var
  OrphyLabAbout: TOrphyLabAbout;

implementation

uses orphyLabDef, orphyLabMainU;

{$R *.DFM}

procedure TOrphyLabAbout.FormActivate(Sender: TObject);
const nomPr : array[boolean] of string = ('morphy2.exe','majorphylab.exe');
begin
     RomLabel.caption := string(OrphyLabMain.chaineVersion);
     Rom1.Visible := OrphyLabMain.faireMaj;
     Rom2.Visible := OrphyLabMain.faireMaj;
     Rom2.caption := nomPr[isOrphyLab];
end;

procedure TOrphyLabAbout.BitBtn1Click(Sender: TObject);
const FileName = 'http://pagesperso-orange.fr/jean-michel.millet/miseajourOrphyLab.html';
begin
  if ShellExecute(Handle, 'open', PChar(FileName), nil, nil, SW_SHOW) <= 32 then
     ShowMessage('Impossible d''accder  '+Filename)
end;

end.

