unit OrphyLabConst;

interface

uses
    SysUtils, Windows;

const
        ZEcho = ansiChar(#10);  // non utilis
        ZRadar = ansiChar(#11); // $0B
        ZRadarAuto = ansiChar(#12); // $0C
        ZStopRadar = ansiChar(#13);  // $0D

        ZRazPosition = ansiChar(#15);
        ZStartPosition = ansiChar(#16);
        ZPosition = ansiChar(#17);
        ZStopPosition = ansiChar(#18);

        ZCodinc = ansiChar(#19);
        ZStopCodinc = ansiChar(#20);

        ZGene = ansiChar(#80);
        ZGeneAcqui = ansiChar(#81);
        ZStopGeneAcqui = ansiChar(#84);
        ZResul = ansiChar(#94);

        ZAP4 = ansiChar(#105);  // i $69
        ZconfSeuil = ansiChar(#108);  // l $6C
        ZstopAcq = ansiChar(#109); // m $6D
        ZGOI = ansiChar(#110); // n $6E
        ZGOF = ansiChar(#111); // $6F
        ZReco = ansiChar(#114); // $72

        ZsetSA = ansiChar(#120);
        Zsbloc = ansiChar(#127);
        
        ZConfEF = ansiChar(#206);
        ZFreq = ansiChar(#212);  // D4
        ZDef = ansiChar(#213); // D5
        ZStopDef = ansiChar(#214); // D6
        Zper = ansiChar(#215); // D7
        ZIdent = ansiChar(#222);
        ZBauds = ansiChar(#223);
        ZReset = ansiChar(#254);

        ZfreqEch = ansiChar(#230);
        Zalim = ansiChar(#229);

resourceString
        erOK='';
        erPhotocolor = 'Tension trop faible ou trop leve';
        trMajResul = 'Attente lecture';
        trFrequence = 'Frquence';
        trDuree = 'Dure';
        trWaitSynchro = 'Attente de dclenchement';
        trAcqEnCours = 'Enregistrement en cours';
        trROM = 'ROM';
        trAcqFinie = 'Acquisition termine';
        trClavier = 'Clavier';
        trTemporel = 'Acquisition temporelle';
        trPointparPoint = 'Point par point';
        trBouton = 'Bouton Acquisition';
        trFront = 'Front';
        trSeuil = 'Seuil';
        trRelaxe = 'Relax';
        trBarre = 'Barre d''espace ou bouton Acquisition';
        trErreur = 'Erreur';
        trMagnum = 'Acquisition avec fouchette optique';
        trReco = '';
        trDeclenche = 'Dclenche';
        trAbscisse = 'Abscisse';
        trEfficace = 'Mesure de valeurs efficaces';
        trRadar = 'Radar';
        trTemps = 'Temps';
        trVerif = '';
        TrErreurCom = 'Erreur  gestion voie srie';
        TrNotOrphy = 'Micro Orphy II non dtect sur ';
        TrYesOrphy2 = 'Micro Orphy II prsent';
        TrYesOrphyLab = 'Orphy Lab prsent';
        trDelAcq = 'Suppression de l''acquisition courante';
        trAttenteMagnum = 'Lecture des donnes de la fourchette optique';
        trDelEtalon = 'Suppression de l''talonnage';
        trAvailResul = 'Lecture des donnes';
        trAvailFreq = 'Dtermination de la frquence';
        trMonocoup = 'Monocoup';
        trBranchez = 'Branchez';
        trDebranchez = 'Pas de capsule';
        trZeroMagnum = 'Origine fixe ; vous pouvez dplacer le mobile';
        trAideFreqTTL = 'Envoyer un signal TTL sur l''entre front';

        erMonocoup = 'Monocoup obligatoire';
        erFileCap = 'Fichier OrphyLab.cap non trouv => impossible ';
        erValeur = 'Valeur';
        erEtalon = 'Points d''talonnage non dfinis';
        erEtalon2 = 'Etalonnage imprcis';
        erHTML = 'Impossible de lancer %s';
        erNombre = 'Nombre mal crit';
        erCarac = 'Caractre non prvu : #';
        erFrequence = 'Impossible de mesurer la frquence';
        erSansSignif = 'Erreur d''acquisition sur une voie';

        hClavier = 'Taper la valeur en haut  droite puis valider pour enregistrer le point courant';
        hPoint = 'Cliquer "Acquisition" ou frappe barre pour enregistrer le point courant|Enregistre le point courant';
        hSynchroClavier =' Cliquer "Acquisition" ou frapper barre pour dmarrer l''enregistrement';
        hSynchroBouton =' Cliquer "Acquisition" pour dmarrer l''enregistrement';
        hAddPoint = '|Enregistre le point courant';
        hStart = '|Lance l''acquisition';
        hEfficace = '|Mesure de valeur efficace';
        hSynchro = 'Dclenchement';
        hSynchroSeuil = 'Synchro seuil';
        hStopPointAuto = 'Dcocher "Automatique" pour arrter l''acquisition';
        hStartPointAuto = 'Cliquer "Acquisition" ou frappe barre pour enregistrer le point courant';
        hPleinEcran = 'Double-clic sur le graphe pour l''agrandir';
        hFinPleinEcran = 'Double-clic sur le graphe pour le rduire';
        hFrequence = 'Frquence';

         trSynchroAna = 'Dclenchement seuil (';
         trSynchro = 'Dclenchement';
         trAcqPAr = 'Acquisition par ';
         trForReg = ' pour Regressi';
         trFiltreTxt = 'Format tableur|*.txt';
         trCreeRepere = 'Cration d''un repre';
         trFreqResp = 'Frq. respiratoire';
         trPosition = 'Position';
         trFiltreCfg = 'Configuration|*.mo2';
         trMesureD = 'Mesure directe';
         trEtalonI = 'Etalonnage interactif';
         trSignif = 'Signification';
         trChoixCapteur = 'Utilisation d''un capteur';
         trAffichage = 'Etendue des mesures de ';
         trSaveModif = 'Sauvegarde des modifications';
         trDelCapteur = 'Suppression de %s';

implementation

end.

