unit OrphyLabUtil;

interface

uses
   SysUtils, Windows, Messages, Classes, Dialogs,
   Graphics, Forms, Printers, Controls, Consts,
   system.UITypes,
   Maths, StdCtrls, orphyLabConst, registry,
   OOmisc, AwUser, LnsWin32, shlObj, math;

const
   WM_File_Load          = WM_USER + 2;
   WM_Acq_Lance          = WM_USER + 3;
   WM_Acq_LanceCardiaque = WM_USER + 4;
   maxAttenteO2 = 3;

   extConfigPortable = '.mo2';

   DeltatLent        = 0.011;
   PrecisionPortable = 4;
   SymbReg: char     = '';
   SymbReg2: char    = '&';
   RegistrePortable  = 'Software\MicroOrphy2';


        alphaR =  AnsiChar(128);
        betaR = AnsiChar(129);
        chiR = AnsiChar(130);
        deltaR = AnsiChar(131); deltaMajR = AnsiChar(150);
        epsilonR = AnsiChar(132);
        phiR = AnsiChar(133); phiMajR = AnsiChar(151);
        gammaR = AnsiChar(134); gammaMajR = AnsiChar(152);
        etaR = AnsiChar(135);
        lambdaR = AnsiChar(136); lambdaMajR = AnsiChar(153);
        nuR = AnsiChar(138);
        piR = AnsiChar(139);piMajR = AnsiChar(154);
        thetaR = AnsiChar(140);thetaMajR = AnsiChar(155);
        rhoR = AnsiChar(141);
        sigmaR = AnsiChar(142);sigmaMajR = AnsiChar(156);
        tauR = AnsiChar(143);
        omegaR = AnsiChar(144);omegaMajR = AnsiChar(157);
        xiR = AnsiChar(147);xiMajR = AnsiChar(158);
        psiR = AnsiChar(148);psiMajR = AnsiChar(159);
        zetaR = AnsiChar(149);
        muR = AnsiChar(181);

        alpha=WideChar($03B1);alphaMaj=WideChar($0391);
        beta=WideChar($03B2);betaMaj=WideChar($0392);
        gamma=WideChar($03B3);gammaMaj=WideChar($0393);
        delta=WideChar($03B4);deltaMaj = WideChar($0394);
        chi=WideChar($03C7);chiMaj=WideChar($03A7);
        epsilon=WideChar($03B5);epsilonMaj=WideChar($0395);
        upsilon=WideChar($03C5);upsilonMaj=WideChar($03A5);
        iota=WideChar($03B9);iotaMaj=WideChar($0399);
        phi=WideChar($03C6);phiMaj=WideChar($03A6);
        eta=WideChar($03B7);etaMaj=WideChar($0397);
        lambdaMaj=WideChar($039B);lambda=WideChar($03BB);
        nu=WideChar($03BD);nuMaj=WideChar($039D);
        xiMaj=WideChar($039E);xi=WideChar($03BE);
        piMin=WideChar($03C0);piMaj=WideChar($03A0);
        thetaMaj=WideChar($0398);theta=WideChar($03B8);
        rho=WideChar($03C1);rhomaj=WideChar($03A1);
        sigma=WideChar($03C3);sigmaMaj=WideChar($03A3);
        tau=WideChar($03C4); tauMaj=WideChar($03A4);
        omega=WideChar($03C9);omegaMaj=WideChar($03A9);
        psi=WideChar($03C8);psiMaj=WideChar($03A8);
        zeta=WideChar($03B6);zetaMaj=WideChar($0396);
        mu=WideChar($03BC);muMaj=WideChar($039C);
        kappa=WideChar($03BA);kappaMaj=WideChar($039A);
        omicron=WideChar($03Bf);omicronMaj=WideChar($039F);
        vide=WideChar(2205);videMaj=WideChar(2205);
        supegal=WideChar(2265);
        infegal=WideChar(2264);

        LettreAccent : tSysCharSet = ['','','','','','','','','',''];

        Grecque = alpha+beta+gamma+gammaMaj+delta+deltaMaj+epsilon+
              chi+zeta+eta+theta+thetaMaj+kappa+
              lambda+lambdaMaj+mu+nu+xi+xiMaj+
              piMin+piMaj+rho+sigma+sigmaMaj+tau+
              phi+phiMaj+phi+phiMaj+psi+psiMaj+omega+omegaMaj;

   ChiffreExp: array['0'..'9'] of wideChar =
  (WideChar($2070),WideChar($00B9),WideChar($00B2),WideChar($00B3),
   WideChar($2074),WideChar($2075),WideChar($2076),WideChar($2077),
   WideChar($2078),WideChar($2079)); // Tahoma 1 2 3 uniquement

    MoinsExp = WideChar($207B); // pas Tahoma
    PlusExp = WideChar($207A);

type
   TlongWordCarac = record
      case byte of
         0: (caracs: array[0..3] of AnsiChar);
         1: (valeurLW: longword);
         2: (valeurW: array[0..1] of word);
         3: (valeurB: array[0..3] of byte);
   end;
   TWordCarac = record
      case byte of
         0: (caracs: array[0..1] of AnsiChar);
         1: (valeurW: word);
         2: (valeurB: array[0..1] of byte);
   end;
   CoefUnite = (zero, yocto, zepto, atto, femto, pico, nano, micro, milli,
      nulle, kilo, mega, giga, tera, peta, exa, zetta, yotta, infini);

const
   UniteMagnum : string = 'm';
   codeBaud : integer = 2; // 115200
   vitesseSerie : array[0..2] of integer = (9600,19200,115200);
   NomMagnum : string = 'z';
   Digits: array[0..$F] of char = '0123456789ABCDEF';
   DureeResul = 0.0005; // 1 octet  115200 bauds
   crSupprArr = char(vk_back);
   crSuppr    = char(vk_clear);
   crHaut     = char(vk_up);
   crBas      = char(vk_down);
   crGauche   = char(vk_left);
   crDroite   = char(vk_right);
   crHome     = char(vk_home);
   crEnd      = char(vk_end);
   crCR       = #13;
   crLF       = #10;
   crESC      = #27;
   crTab      = char(vk_tab);
   Separateur= [' ', crTab, ','];
   Majuscule= ['A'..'Z'];
   Minuscule= ['a'..'z'];
   ToutCarac = [#032..#151, #224..#250];
   Chiffre= ['0'..'9'];
   ChiffrePuiss= [#186, #185, #178, #179, #165, #169, #172, #173, #174, #188];
   ChiffreEtc= ['0'..'9', '+', '-', 'e', 'E', '.'];
   ChiffreWin= ['0'..'9', '+', '-', 'e', 'E', '.', ','];
   ToucheEdition= [crSupprArr, crGauche, crDroite, crHome, crEnd, crSuppr];

   CaracPrefixe=
      ['a', 'f', 'p', 'n', '', 'm', 'd', 'c', 'h', 'k', 'M', 'G', 'T', 'P', 'E'];
   CaracUnite=
      ['A'..'Z', 'a'..'z', OmegaMaj, '1'..'3', '-', '.', '/', ''];
   prefixeUnite: array[coefunite] of char =
      ('0', 'y', 'z', 'a', 'f', 'p', 'n', '', 'm',
      ' ', 'k', 'M', 'G', 'T', 'P', 'E', 'Z', 'Y', '');
   valUnite: array[coefunite] of double =
      (1E-27, 1E-24, 1E-21, 1E-18, 1E-15, 1E-12, 1E-9, 1E-6, 1E-3,
      1, 1E+3, 1E+6, 1E+9, 1E+12, 1E+15, 1E+18, 1E+21, 1E+24, 1E+27);
   puissanceUnite: array[coefunite] of shortint =
      (-27, -24, -21, -18, -15, -12, -9, -6, -3,
      0, +3, +6, +9, +12, +15, +18, +21, +24, +27);
   expUnite: array[coefUnite] of string =
      ('E-27', 'E-24', 'E-21', 'E-18', 'E-15', 'E-12', 'E-9', 'E-6', 'E-3',
      '', 'E+3', 'E+6', 'E+9', 'E+12', 'E+15', 'E+18', 'E+21', 'E+24', 'E+27');

function OKReg(NumOK: string): boolean;
procedure Info(NumInfo: string);
procedure afficheErreur(NumErreur: string);
function ToucheValidation(key: word): boolean;
procedure TrimComplet(var S: string);
function Pad(S: string; Len: integer): string;
function ConvertitChaine(nombre: string; var valeur: double): boolean;
function FloatToStrPoint(valeur: double): string;
function FormatPortable(nombre: double): string;
function FormatTimeCourt(nombre: double): string;
function PuissToStr(puiss: integer): string;
function CompareStr(s1, s2: string): boolean;
function StrToFloatWin(nombre: string): double;
function EncodeDuree(duree: longint): TdateTime;
function DureeEcoulee(InstantDebut: TdateTime): double;
function CaracToChiffre(carac: char): integer;
function IsPortAvailable(ComNum: cardinal): boolean;
function Duree125(duree: double): double;
Function UnicodeVersRW3(s : string) : string;

var
   mesDocsDir,appDataDir: string;
   nomFichierConfig,nomFichierCapteur: string;

implementation

procedure TrimComplet(var s: string);
var
   longueur, posCourant: integer;
begin
   longueur := Length(s);
   posCourant := 1;
   while (posCourant <= longueur) do
      if Ord(s[posCourant]) <= 32 then begin
         Delete(s, posCourant, 1);
         Dec(longueur);
      end
      else
         Inc(posCourant);
end;

function OKReg(NumOK: string): boolean;
begin
   OKreg := MessageDlg(NumOK, mtConfirmation, [mbYes, mbNo], 0) = idYes;
end;

procedure Info(NumInfo: string);
begin
   MessageDlg(NumInfo, mtInformation, [mbOK], 0);
end;

procedure ConvertitPrefixe(var nombre: string);
var
   u: coefUnite;
   c: char;
begin
   c := nombre[length(nombre)];
   if charinset(c,caracPrefixe) then begin
      u := zero;
      repeat
         Inc(u)
      until (c = prefixeUnite[u]);
      Delete(nombre, length(nombre), 1);
      nombre := nombre + expUnite[u];
   end;
end;

function StrToFloatWin(nombre: string): double;
var
   posSeparator: integer;
begin
   if FormatSettings.decimalSeparator <> '.' then begin
      posSeparator := pos('.', nombre);
      if posSeparator > 0 then
         Nombre[posSeparator] := FormatSettings.decimalSeparator;
   end
   else if FormatSettings.decimalSeparator <> ',' then begin
      posSeparator := pos(',', nombre);
      if posSeparator > 0 then
         Nombre[posSeparator] := FormatSettings.decimalSeparator;
   end;
   ConvertitPrefixe(nombre);
   try
      StrToFloatWin := strToFloat(nombre);
   except
      StrToFloatWin := Nan;
   end;
end;

function FloatToStrPoint(valeur: double): string;
var
   nombre: string;
   posSeparator: integer;
begin
   nombre := FloatToStrF(valeur, ffGeneral, 7, 2);
   if FormatSettings.decimalSeparator <> '.' then begin
      posSeparator := pos(FormatSettings.decimalSeparator, nombre);
      if posSeparator > 0 then
         Nombre[posSeparator] := '.';
   end;
   Result := nombre;
end;

function ConvertitChaine(nombre: string; var valeur: double): boolean;
begin
   if (upcase(nombre[1]) = 'E') then
      nombre := '1' + nombre
   else if nombre[1] = '.' then
      nombre := '0' + nombre;
   valeur := StrToFloatWin(nombre);
   convertitChaine := not isNan(valeur);
end;

function FormatGeneral(Nombre: double; Nchiffres: integer): string;
var
   Nexp: integer;
begin
   if isNan(Nombre) then begin
      FormatGeneral := ' ';
      exit;
   end;
   if (abs(Nombre) < 1e-10) or (abs(Nombre) < 1e+10) then
      Nexp := 2
   else Nexp := 1;
   FormatGeneral := FloatToStrF(nombre, ffGeneral, Nchiffres, Nexp);
end;

function FormatPortable(Nombre: double): string;
begin
   Result := FormatGeneral(Nombre, 6);
end;

function FormatTimeCourt(Nombre: double): string;
begin
   result := FormatGeneral(Nombre, 3);
end;

procedure afficheErreur(NumErreur: string);
var
   SauveCursor: Tcursor;
begin
   SauveCursor := Screen.cursor;
   Screen.cursor := crDefault;
   MessageDlg(NumErreur, mtError, [mbOK], 0);
   Screen.cursor := SauveCursor;
end;

function PuissToStr(puiss: integer): string;
var
   dest: string;
   i: integer;
begin
   if puiss = 0 then
      dest := ''
   else
      dest := IntToStr(puiss);
   for i := 1 to length(dest) do
      case dest[i] of
         '0'..'9': dest[i] := chiffreExp[dest[i]];
         '-' : dest[i] := moinsExp;
         '+' : dest[i] := plusExp;
      end;
   PuissToStr := dest;
end;

function CompareStr(s1, s2: string): boolean;
begin
   s1 := upperCase(s1);
   s2 := upperCase(s2);
   compareStr := s1 = s2;
end;

function ToucheValidation(key: word): boolean;
begin
   ToucheValidation := key in [vk_tab, vk_left, vk_right, vk_down, vk_up, vk_return];
end;

procedure Validatedouble(Sender: Tedit; var z: double);
begin
   z := StrToFloatWin(Sender.Text);
   if isNan(z) then
      Sender.Text := FloatToStr(z);
end;

function Pad(S: string; Len: integer): string;
// Return a string right-padded to length len with ' '
var
   i,Slen: integer;
begin
   Slen := length(S);
   if SLen >= Len then
      result := copy(S, 1, Len)
      else begin
        result := S;
        for i := Slen+1 to len do result := result+' ';
      end;
end;

function EncodeDuree(duree: longint): TdateTime;
var
   h, m, s, ms: word;
begin
   h  := duree div 3600;
   duree := duree - h * 3600;
   m  := duree div 60;
   duree := duree - m * 60;
   s  := duree;
   ms := 0;
   EncodeDuree := EncodeTime(h, m, s, ms);
end;

function DureeEcoulee(InstantDebut: TdateTime): double;
var
   h, m, s, ms: word;
begin
   decodeTime(now - instantDebut, h, m, s, ms);
   DureeEcoulee := h * 3600.0 + m * 60.0 + s * 1.0 + ms * 0.001;
end;

function CaracToChiffre(carac: char): integer;
var i : ansiChar;
begin
   result := 0;
   if charinset(carac,chiffre) then
      Result := Ord(carac) - Ord('0')
   else for i := '0' to '9' do
        if carac=chiffreExp[i] then begin
           result := ord(i)-ord('0');
           break;
           end;
end;

function IsPortAvailable(ComNum: cardinal): boolean;

   function MakeComName(const Dest: PChar; const ComNum: cardinal): PChar;
// Return a string like 'COMXX'
   begin
      StrFmt(Dest, '\\.\COM%d', [ComNum]);
      MakeComName := Dest;
   end;

var
   ComName: array[0..12] of char;
   Res: integer;
   DeviceLayer: TApdBaseDispatcher;
begin
   DeviceLayer := TApdWin32Dispatcher.Create(nil);
   try
      if (ComNum = 0) then
         Result := False
      else begin
         Res := DeviceLayer.OpenCom(MakeComName(ComName, ComNum), 64, 64);
         if (Res < 0) and (GetLastError <> DWORD(Abs(ecAccessDenied))) then
            Result := False
         else begin
            Result := True;
            DeviceLayer.CloseCom;
         end;
      end;
   finally
      DeviceLayer.Free;
   end;
end;

function AddBackSlash(aPath: string): string;
begin
   Result := EmptyStr;
   if (aPath <> '') and (aPath[Length(aPath)] <> '\') then
      Result := aPath + '\';
end;

// permet de retrouver un repertoire d'aprs sa valeur CSIDL
function GetFolder(CSIDLValue: integer): string;
var
   IdList: PITEMIDLIST;
   Folder: array[0..MAX_PATH] of char;
begin
   if not Failed(SHGetSpecialFolderLocation(0, CSIDLValue, IdList)) then begin
      SHGetPathFromIDList(IdList, Folder);
      Result := AddBackSlash(Folder);
   end;
end;

function duree125(duree: double): double;
var
   exposant, mantisse, coeff: double;
begin
   exposant := MyInt(log(duree));
   coeff := exp(exposant * ln10);
   mantisse := round(duree / coeff);
   if mantisse > 2 then
      if mantisse < 6
         then mantisse := 5
         else mantisse := 10;
   duree125 := mantisse * coeff;
end;

Function UnicodeVersRW3(s : string) : string;
var i : integer;
    carac : char;
    caracR : char;
begin
     result := '';
     for i := 1 to length(s) do begin
         carac := s[i];
         if pos(carac,grecque)>0
            then case carac of
                      alpha : caracR := alphaR;
                      beta : caracR := betaR;
                      gamma: caracR := gammaR;
                      gammaMaj: caracR := gammaMajR;
                      delta: caracR := deltaR;
                      deltaMaj: caracR := deltaMajR;
                      epsilon: caracR := epsilonR;
                      zeta: caracR := zetaR;
                      eta: caracR := etaR;
                      kappa: caracR := 'k';
                      lambda: caracR := lambdaR;
                      lambdaMaj: caracR := lambdaMajR;
                      mu: caracR := '';
                      nu: caracR := nuR;
                      xi: caracR := xiR;
                      xiMaj: caracR := xiMajR;
                      pimin: caracR := piR;
                      piMaj: caracR := piMajR;
                      rho: caracR := rhoR;
                      sigma: caracR := sigmaR;
                      sigmaMaj: caracR := sigmaMajR;
                      tau: caracR := tauR;
                      theta: caracR := thetaR;
                      thetaMaj: caracR := thetaMajR;
                      phi: caracR := phiR;
                      phiMaj: caracR := phiMajR;
                      chi: caracR := chiR;
                      psi: caracR := psiR;
                      psiMaj: caracR := psiMajR;
                      omega: caracR := omegaR;
                      omegaMaj: caracR := omegaMajR;
                      else caracR := '?';
                 end
            else caracR := carac;
            result := result+caracR;
     end;
end;

initialization
   mesDocsDir := GetFolder(CSIDL_Personal)+'Regressi';
   if not DirectoryExists(MesDocsDir) then
      createDir(MesDocsDir);
   MesDocsDir := AddBackSlash(MesDocsDir);
   appDataDir := GetFolder(CSIDL_AppData)+'Regressi';
   if not DirectoryExists(appDataDir) then
       createDir(appDataDir);
   appDataDir := AddBackSlash(appDataDir);
   NomFichierConfig := appDataDir + 'OrphyLab';
   NomFichierCapteur := changeFileExt(application.exename,'.cap');
end.

