unit capsuleCfgU;

interface

uses Windows, Classes, Graphics, Forms, Controls, StdCtrls, Tabs,
  Buttons, ExtCtrls, sysutils, ComCtrls,
  orphyLabDef, orphyLabUtil, orphyLabGraphe, aidekey;

type
  TCapsuleCfgDlg = class(TForm)
    ButtonPanel: TPanel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Notebook: TPageControl;
    TabSheet1: TTabSheet;
    EditTitre: TLabeledEdit;
    EditAide: TLabeledEdit;
    TabSheet3: TTabSheet;
    GroupBox1: TGroupBox;
    MiniEdit: TLabeledEdit;
    MaxiEdit: TLabeledEdit;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    CapsuleCourante : TCapsule;
  public
    VoieCourante : Tcourbe;
  end;

var
  CapsuleCfgDlg: TCapsuleCfgDlg;

implementation

{$R *.DFM}

procedure TCapsuleCfgDlg.FormActivate(Sender: TObject);
begin
capsuleCourante := voieCourante.capsule;
with capsuleCourante do begin
     EditAide.text := capteurC;
     EditTitre.text := titreC;
     MiniEdit.text := FormatPortable(valeur0);
     MaxiEdit.text := FormatPortable(valeur1024);
end end;

procedure TCapsuleCfgDlg.OKBtnClick(Sender: TObject);
begin
with capsuleCourante do begin
     capteurC := EditAide.text;
     titreC := EditTitre.text;
     valeur0 := strToFloatWin(miniEdit.text);
     valeur1024 := strToFloatWin(maxiEdit.text);
     voieCourante.setMinMax(valeur0,valeur1024);
end;
with voieCourante do begin
     capteur := EditAide.text;
     titre := EditTitre.text;
     GBvoie.Caption := GBcaption;
     GBvoie.Hint := capteur;
end;
end;

end.

