unit curseursU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, orphyLabGraphe;

type
  TCurseursForm = class(TForm)
    Grid: TStringGrid;
    procedure GridDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
  public
  end;

var
  CurseursForm: TCurseursForm;

implementation

uses orphyLabMainU;

{$R *.dfm}

procedure TCurseursForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    OrphyLabMain.curseursBtn.down := false;
    graphe.curseursActifs := false;
    OrphyLabMain.oscillo.refresh;
end;

procedure TCurseursForm.GridDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var rr : integer;
    s : String;
begin
     rr := (Arow mod 3)+1;
     Grid.canvas.Font.Color := couleurCurseur[rr];
     S := Grid.cells[Acol,Arow];
     grid.canvas.TextOut(Rect.Left + 2, Rect.Top + 2,S);
end;

end.
