unit options_ligne;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Buttons,
  system.UITypes,
  StdCtrls, ExtCtrls, Messages, Dialogs, ImgList, ComCtrls, Spin, CheckLst,
  orphyLabConst, uniteKer, orphyLabGraphe;

type
  TOptionLigneDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    PenBar: TPanel;
    PenSize: TLabel;
    PenWidth: TScrollBar;
    CouleurCombo: TColorBox;
    LigneCombo: TComboBoxEx;
    ImageLigne: TImageList;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
  public
    DessinLoc : Tdessin;
    Agraphe : Tgraphe;
  end;

var
  OptionLigneDlg: TOptionLigneDlg;

implementation

{$R *.DFM}

procedure TOptionLigneDlg.FormActivate(Sender: TObject);
begin with dessinLoc do begin
        CouleurCombo.selected := pen.color;
        LigneCombo.itemIndex := ord(pen.style);
end end;

procedure TOptionLigneDlg.OKBtnClick(Sender: TObject);
begin with DessinLoc do begin
       pen.color := CouleurCombo.selected;
       pen.style := TpenStyle(LigneCombo.itemIndex);
end end;

end.
