unit ListeCapVolt;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons, StdCtrls, ExtCtrls,
  orphyLabdef, orphyLabGraphe, orphyLabUtil, orphyLabConst;

type
  TListeCapteursVoltDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    ListeCapteursBox: TListBox;
    procedure FormActivate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
  public
    voieCourante : indiceVoie;
  end;

var
  ListeCapteursVoltDlg: TListeCapteursVoltDlg;

implementation

uses orphyLabMainU;

{$R *.DFM}

procedure TListeCapteursVoltDlg.FormActivate(Sender: TObject);
var i : integer;
    ligne : string;
begin with ListeCapteursBox.Items do begin
     Clear;
     for i := 0 to pred(listeCapteur.count) do
         with listeCapteur.items[i] do begin
              ligne := Pad(nomC,5);
              if signifC<>'' then ligne := ligne+' : ' +signifC;
              if titreC<>'' then ligne := ligne+' ; ' +titreC;
              Add(ligne);
         end;
     ListeCapteursBox.itemIndex := 0;
end end;

procedure TListeCapteursVoltDlg.OKBtnClick(Sender: TObject);
var capteurCourant : TCapteur;
begin
    if ListeCapteursBox.itemIndex>=0 then begin
       CapteurCourant := listeCapteur.items[ListeCapteursBox.itemIndex];
       graphe.voieOrphy[voieCourante].getCapteurVolt(CapteurCourant);
    end;
end;

end.
