unit VumetreU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Forms,
  Dialogs, ExtCtrls, Math,
  OrphyLabGraphe, OrphyLabDef, StdCtrls, Controls;

// Abakus VCL 300 euros
// SDL VCL 248 euros

type
  TVumetreForm = class(TForm)
    GridPanel1: TGridPanel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    GroupBox3: TGroupBox;
    Label3: TLabel;
    GroupBox4: TGroupBox;
    Label4: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure GridPanel1Resize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
  private
    procedure SetSizeVoie;
  public
  end;

var
  VumetreForm: TVumetreForm;

implementation

uses OrphyLabMainU;

{$R *.dfm}

procedure TVumetreForm.FormActivate(Sender: TObject);
begin
      setSizeVoie;
end;

procedure TVumetreForm.FormHide(Sender: TObject);
begin
   orphyLabMain.vuMetreBtn.down := false;
end;

procedure TVumetreForm.FormResize(Sender: TObject);
begin
	setSizeVoie;
end;

procedure TVumetreForm.FormShow(Sender: TObject);
begin
	setSizeVoie;
end;

procedure TVumetreForm.GridPanel1Resize(Sender: TObject);
begin
	setSizeVoie;
end;

procedure TVumetreForm.SetSizeVoie;
var
   voie: indiceVoie;
   hauteur,largeur,nbre : integer;
begin
      nbre := 0;
      for voie := 0 to graphe.voieAnaMax do with graphe.voieOrphy[voie] do begin
          if active then begin
             case nbre of
                  0 : begin
                    gbVumetre := groupBox1;
                    labelVumetre := label1;
                  end;
                  1 : begin
                    gbVumetre := groupBox2;
                    labelVumetre := label2;
                  end;
                  2 : begin
                    gbVumetre := groupBox3;
                    labelVumetre := label3;
                  end;
                  3 : begin
                    gbVumetre := groupBox4;
                    labelVumetre := label4;
                  end;
             end;
             inc(nbre);
          end;
      end;
      with graphe.voieOrphy[voieCalc] do if active then begin
            case nbre of
                  0 : begin
                    gbVumetre := groupBox1;
                    labelVumetre := label1;
                  end;
                  1 : begin                                  
                    gbVumetre := groupBox2;
                    labelVumetre := label2;
                  end;
                  2 : begin
                    gbVumetre := groupBox3;
                    labelVumetre := label3;
                  end;
                  3 : begin
                    gbVumetre := groupBox4;
                    labelVumetre := label4;
                  end;
             end;
             inc(nbre);
      end;
      if nbre=1 then begin
         GridPanel1.columnCollection[0].value := 100;
         GridPanel1.columnCollection[1].value := 0;
         GridPanel1.rowCollection[0].value := 100;
         GridPanel1.rowCollection[1].value := 0;
      end;
      if nbre=2 then begin
         GridPanel1.columnCollection[0].value := 100;
         GridPanel1.columnCollection[1].value := 0;
         GridPanel1.rowCollection[0].value := 50;
         GridPanel1.rowCollection[1].value := 50;
      end;
      if nbre>2 then begin
         GridPanel1.columnCollection[0].value := 50;
         GridPanel1.columnCollection[1].value := 50;
         GridPanel1.rowCollection[0].value := 50;
         GridPanel1.rowCollection[1].value := 50;
      end;
   Hauteur := GroupBox2.Height;
   Largeur := GroupBox1.Width div 8;
   if largeur < 11 then largeur := 11;
   if hauteur > 3*largeur then hauteur := 3*largeur;
   for voie := voie0 to graphe.voieAnaMax do
      with graphe.voieOrphy[voie] do if active then begin
            GBvumetre.caption := GBvoie.caption;
            GBvumetre.font.color := couleur;
            Labelvumetre.font.color := couleur;
            GBvumetre.font.Height := 2*(hauteur div 6);
            LabelVumetre.font.Height := 2*(hauteur div 3);
            LabelVumetre.top := hauteur div 3;
         end;
   with graphe.voieOrphy[voieCalc] do if active then begin
           GBvumetre.caption := GBvoie.caption;
           Hauteur := GBvumetre.Height;
           GBvumetre.font.color := couleur;
           Labelvumetre.font.color := couleur;
           GBvumetre.font.Height := 2*(hauteur div 6);
           LabelVumetre.font.Height := 2*(hauteur div 3);
           LabelVumetre.top := hauteur div 3;
   end
   else begin
      GBvumetre.caption := '';
      LabelVumetre.caption := '';
   end;
end;

end.
