unit Sbdlg;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, spin, ExtCtrls, sysutils, Grids, Dialogs, 
  orphyLabUtil, orphyLabDef, orphyLabGraphe, orphyLabConst, aidekey;

type
  TSortieBinDlg = class(TForm)
    OKBtn: TBitBtn;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    HelpBtn: TBitBtn;
    NbreSE: TSpinEdit;
    Label4: TLabel;
    LargeurSE: TSpinEdit;
    Label6: TLabel;
    Label2: TLabel;
    DistanceSE: TSpinEdit;
    Oscillo: TPaintBox;
    LargeurEdit: TEdit;
    DistanceEdit: TEdit;
    Label1: TLabel;
    DebutEdit: TEdit;
    DebutSE: TSpinEdit;
    procedure FormActivate(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure NbreSEChange(Sender: TObject);
    procedure LargeurSEChange(Sender: TObject);
    procedure DistanceSEChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DebutSEChange(Sender: TObject);
  private
  public
  end;

var
  SortieBinDlg: TSortieBinDlg;

implementation

{$R *.DFM}

procedure TSortieBinDlg.FormActivate(Sender: TObject);
begin with sortieBinaire do begin
        NbreSE.value := nbrePulse;
        largeurSE.value := largeurPulse;
        distanceSE.value := DistancePulse;
        debutSE.value := DebutPulse;
end end;

procedure TSortieBinDlg.HelpBtnClick(Sender: TObject);
begin
   Application.HelpContext(HELP_GenerationImpulsion)
end;

procedure TSortieBinDlg.OscilloPaint(Sender: TObject);
begin with sortieBinaire do begin
     limiteFenetre := rect(0,0,oscillo.width-1,oscillo.height-1);
     calcVecteur;
     draw;
end end;

procedure TSortieBinDlg.NbreSEChange(Sender: TObject);
begin
       sortieBinaire.NbrePulse := NbreSE.value;
       oscillo.refresh;
end;

procedure TSortieBinDlg.LargeurSEChange(Sender: TObject);
begin
       sortieBinaire.LargeurPulse := LargeurSE.value;
       LargeurEdit.text := FloatToStrF(LargeurSE.value*PasSortieBinaire*1000,ffFixed,4,1);
       distanceSE.minValue := largeurSE.value+1;
       oscillo.refresh;
end;

procedure TSortieBinDlg.DistanceSEChange(Sender: TObject);
begin
       sortieBinaire.DistancePulse := DistanceSE.value;
       DistanceEdit.text := FloatToStrF(DistanceSE.value*PasSortieBinaire*1000,ffFixed,4,1);
       oscillo.refresh;
end;

procedure TSortieBinDlg.FormCreate(Sender: TObject);
begin
      sortieBinaire.canvas := oscillo.canvas
end;

procedure TSortieBinDlg.DebutSEChange(Sender: TObject);
begin
       sortieBinaire.DebutPulse := DebutSE.value;
       DebutEdit.text := FloatToStrF(DebutSE.value*PasSortieBinaire*1000,ffFixed,4,1);
       oscillo.refresh;
end;

end.
